/* 
    channel for Bt848 frame grabber driver

    Copyright (C) 1996,97 Marcus Metzler (mocm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * channel.cc 
 */

#include "channel.h"
#include <string.h>

channel::channel(int freq,const char *n,int c,int b,int hu,int co,int no,int in,
		 int start=0)
{
  name=new char[strlen(n)+1];
  strcpy(name,n);
  frequency=freq;
  color=c;
  brightness=b;
  hue=hu;
  contrast=co;
  norm=no;
  input=in;
  startwiththis=start;
}


channel::~channel()
{
  delete(name);
}

ostream &operator<<(ostream &stream, channel &x)
{
  stream << "*" << endl;
  stream << "Channel: " << x.name << endl;
  stream << "Frequency: " << x.frequency << endl;
  stream << "CBHC: " << x.color << " "; 
  stream << x.brightness << " "; 
  stream << x.hue << " "; 
  stream << x.contrast << endl; 
  stream << "NIS: " << x.norm << " "; 
  stream << x.input << " " << x.startwiththis << endl; 
}

istream &operator>>(istream &stream, channel &x)
{
  char cdummy[50];
  
  if (x.xtvscreen_file) {
    stream >> cdummy >> cdummy;
    if (x.name) delete(x.name);
    x.name=new char[sizeof(cdummy)];
    strcpy(x.name,cdummy);
    stream.get(cdummy,sizeof(cdummy)); // get full channel name
    strcat(x.name,cdummy);
    
    stream >> cdummy >> x.frequency >> cdummy >> x.color >> x.brightness;
    stream >> x.hue >> x.contrast >> cdummy >> x.norm >> x.input; 
  } else {
    stream >> cdummy >> cdummy;
    if (x.name) delete(x.name);
    x.name=new char[sizeof(cdummy)];
    strcpy(x.name,cdummy);
    stream.get(cdummy,sizeof(cdummy)); // get full channel name
    strcat(x.name,cdummy);
  
    stream >> cdummy >> x.frequency >> cdummy >> x.color >> x.brightness;
    stream >> x.hue >> x.contrast >> cdummy >> x.norm >> x.input >> x.startwiththis; 
  }
}


